-----------------------------------------------------------------
-- (c) 2007 VUT-FEL, K336
-- http://cs.felk.cvut.cz
-----------------------------------------------------------------
-- Filename : ctrltb.vhd
-- Revision : V1.1
-- Author :   Josef Nouzk
-- Created :  22. 04. 2007
--
-- Modifications
-- 2.0	04. 05. 2007 by Zdenk Sojka
-- 1.0	22. 04. 2007 by Josef Nouzk
-----------------------------------------------------------------
-- testbench pro adi
--
-- 2.0	odstrann signlu 'load', pidn signlu 'valid'
-----------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY ctrltb_vhd IS
END ctrltb_vhd;

ARCHITECTURE behavior OF ctrltb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT ctrl
	PORT(
		zeroA : IN std_logic;
		zero0 : IN std_logic;
		btnA : IN std_logic;
		btnB : IN std_logic;
		clk : IN std_logic;
		rst : IN std_logic;          
		setA : OUT std_logic;
		setB : OUT std_logic;
		shrA : OUT std_logic;
		shlB : OUT std_logic;
		resV : OUT std_logic;
		valid : OUT std_logic;
		k1 : OUT std_logic;
		k2 : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL zeroA :  std_logic := '0';
	SIGNAL zero0 :  std_logic := '0';
	SIGNAL btnA :  std_logic := '0';
	SIGNAL btnB :  std_logic := '0';
	SIGNAL clk :  std_logic := '0';
	SIGNAL rst :  std_logic := '0';

	--Outputs
	SIGNAL setA :  std_logic;
	SIGNAL setB :  std_logic;
	SIGNAL shrA :  std_logic;
	SIGNAL shlB :  std_logic;
	SIGNAL resV :  std_logic;
	SIGNAL valid :  std_logic;
	SIGNAL k1 :  std_logic;
	SIGNAL k2 :  std_logic;

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: ctrl PORT MAP(
		zeroA => zeroA,
		zero0 => zero0,
		btnA => btnA,
		btnB => btnB,
		setA => setA,
		setB => setB,
		shrA => shrA,
		shlB => shlB,
		resV => resV,
		valid => valid,
		k1 => k1,
		k2 => k2,
		clk => clk,
		rst => rst
	);

	hodiny : PROCESS

	begin
		clk <= '0';
		wait for 10 ns;
		clk <= '1';
		wait for 10 ns;
	end process;

	tb : PROCESS
	
	variable err_cnt: integer :=0;
	
	BEGIN

		-- Wait 100 ns for global reset to finish
		rst <= '1';
		wait for 100 ns;
		rst <= '0';
		btnA <= '1';
		wait for 100 ns;
		btnA <= '0';
		wait for 100 ns;
		btnB <= '1';
		wait for 100 ns;
		btnB <= '0';

		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
